declare type IGenericField<T, Co> = Co | {
    type: Co;
    default?: T;
    optional?: boolean;
};
declare type IValidTypes = string | number | boolean;
declare type ITestField<T1 extends IValidTypes, T2 extends IValidTypes, R> = T1 extends T2 ? R : never;
export declare type IField<F extends IValidTypes> = ITestField<F, string, IGenericField<string, StringConstructor>> | ITestField<F, number, IGenericField<number, NumberConstructor>> | ITestField<F, boolean, IGenericField<boolean, BooleanConstructor>>;
export declare type IConfigInterface = {
    [category: string]: {
        [field: string]: IValidTypes;
    };
};
export declare type IConfig<T extends IConfigInterface> = {
    [category in keyof T]: {
        [field in keyof T[category]]: IField<T[category][field]>;
    };
};
declare function parse<T extends IConfigInterface>(config: IConfig<T>, path?: string): T;
declare function parseAsync<T extends IConfigInterface>(config: IConfig<T>, path: string): Promise<T>;
export { parse, parseAsync };
